package com.giderosmobile.android.plugins.googlelicensing;

import java.lang.ref.WeakReference;

import com.giderosmobile.android.plugins.googlelicensing.LicenseChecker;
import com.giderosmobile.android.plugins.googlelicensing.LicenseCheckerCallback;
import com.giderosmobile.android.plugins.googlelicensing.Policy;
import com.giderosmobile.android.plugins.googlelicensing.ServerManagedPolicy;
import com.giderosmobile.android.plugins.googlelicensing.AESObfuscator;
import android.provider.Settings.Secure;

import android.app.Activity;

public class GoogleLVL implements LicenseCheckerCallback {
	//reference to main activity
	private static WeakReference<Activity> sActivity;	
	private static GoogleLVL mLicenseCheckerCallback;
	private static LicenseChecker mChecker;
	private static String deviceID;
	
	private static final byte[] SALT = new byte[] {
	     -46, 65, 30, -128, -103, -57, 74, -64, 51, 88, -95,
	     -45, 77, -117, -36, -113, -11, 32, -64, 89
	};
	
	/****************
	 * Here we will register to all
	 * Application life cycle events
	 ****************/
	
	//on create event from Gideros
	//receives reference to current activity
	//just in case if you might need it
	public static void onCreate(Activity activity)
	{
		//reference to activity
		sActivity =  new WeakReference<Activity>(activity);
		deviceID = Secure.getString(sActivity.get().getContentResolver(), Secure.ANDROID_ID);
	}
	
	//on destroy event
	public static void onDestroy()
	{
		 mChecker.onDestroy();	
	}
	
	@Override
	public void allow(int reason) {
		GoogleLVL.onLicenseAllowed(reason);
	}

	@Override
	public void dontAllow(int reason) {
		if (reason == Policy.RETRY) {
			GoogleLVL.onLicenseRetry(reason);
        } else {
        	GoogleLVL.onLicenseDisallowed(reason);
        }
	}

	@Override
	public void applicationError(int errorCode) {
		// TODO Auto-generated method stub
		
	}
	
	public static void setKey(String id){
		// Construct the LicenseCheckerCallback. The library calls this when done.
        mLicenseCheckerCallback = new GoogleLVL();

        // Construct the LicenseChecker with a Policy.
        mChecker = new LicenseChecker(
        	sActivity.get(), new ServerManagedPolicy(sActivity.get(),
                new AESObfuscator(SALT, "com.giderosmobile.android", deviceID)),
            id  // Your public licensing key.
        );
       
	}
	public static void checkLicense(){
		 mChecker.checkAccess(mLicenseCheckerCallback);
	}
	
	
	private static native void onLicenseAllowed(int reason);
	private static native void onLicenseDisallowed(int reason);
	private static native void onLicenseRetry(int reason);
}
